//$HeadURL: https://svn.wald.intevation.org/svn/deegree/base/branches/2.3_testing/src/org/deegree/ogcwebservices/sos/capabilities/SOSOperationsMetadata.java $
/*----------------------------------------------------------------------------
 This file is part of deegree, http://deegree.org/
 Copyright (C) 2001-2009 by:
   Department of Geography, University of Bonn
 and
   lat/lon GmbH

 This library is free software; you can redistribute it and/or modify it under
 the terms of the GNU Lesser General Public License as published by the Free
 Software Foundation; either version 2.1 of the License, or (at your option)
 any later version.
 This library is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 details.
 You should have received a copy of the GNU Lesser General Public License
 along with this library; if not, write to the Free Software Foundation, Inc.,
 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

 Contact information:

 lat/lon GmbH
 Aennchenstr. 19, 53177 Bonn
 Germany
 http://lat-lon.de/

 Department of Geography, University of Bonn
 Prof. Dr. Klaus Greve
 Postfach 1147, 53001 Bonn
 Germany
 http://www.geographie.uni-bonn.de/deegree/

 e-mail: info@deegree.org
----------------------------------------------------------------------------*/
package org.deegree.ogcwebservices.sos.capabilities;

import org.deegree.ogcwebservices.getcapabilities.Operation;
import org.deegree.ogcwebservices.getcapabilities.OperationsMetadata;

/**
 * Describe the OWS OperationsMetadata, is a part of the SCS Capabilities
 *
 * @author <a href="mailto:mkulbe@lat-lon.de">Matthias Kulbe</a>
 *
 * @version 1.0
 */
public class SOSOperationsMetadata extends OperationsMetadata {

    private static final long serialVersionUID = -3805760523604081523L;

    /**
     *
     */
    public static final String DESCRIBE_PLATFORM_NAME = "DescribePlatform";

    /**
     *
     */
    public static final String DESCRIBE_SENSOR_NAME = "DescribeSensor";

    /**
     *
     */
    public static final String GET_OBSERVATION_NAME = "GetObservation";

    private Operation describePlatform;

    private Operation describeSensor;

    private Operation getObservation;

    /**
     * constructor
     *
     * @param getCapabilities
     * @param describePlatform
     * @param describeSensor
     * @param getObservation
     */
    public SOSOperationsMetadata( Operation getCapabilities, Operation describePlatform, Operation describeSensor,
                                  Operation getObservation ) {

        super( getCapabilities, null, null );

        this.describePlatform = describePlatform;
        this.describeSensor = describeSensor;
        this.getObservation = getObservation;

    }

    @Override
    public Operation[] getOperations() {
        return new Operation[] { getCapabilitiesOperation, describePlatform, describeSensor, getObservation };
    }

    /**
     *
     * @return describePlatform
     */
    public Operation getDescribePlatform() {
        return describePlatform;
    }

    /**
     *
     * @param describePlatform
     */
    public void setDescribePlatform( Operation describePlatform ) {
        this.describePlatform = describePlatform;
    }

    /**
     *
     * @return describeSensor
     */
    public Operation getDescribeSensor() {
        return describeSensor;
    }

    /**
     *
     * @param describeSensor
     */
    public void setDescribeSensor( Operation describeSensor ) {
        this.describeSensor = describeSensor;
    }

    /**
     *
     * @return getObservation
     */
    public Operation getGetObservation() {
        return getObservation;
    }

    /**
     *
     * @param getObservation
     */
    public void setGetObservation( Operation getObservation ) {
        this.getObservation = getObservation;
    }
}
