//$HeadURL: https://svn.wald.intevation.org/svn/deegree/base/branches/2.3_testing/src/org/deegree/ogcwebservices/sos/configuration/SOSConfiguration.java $
/*----------------------------------------------------------------------------
 This file is part of deegree, http://deegree.org/
 Copyright (C) 2001-2009 by:
   Department of Geography, University of Bonn
 and
   lat/lon GmbH

 This library is free software; you can redistribute it and/or modify it under
 the terms of the GNU Lesser General Public License as published by the Free
 Software Foundation; either version 2.1 of the License, or (at your option)
 any later version.
 This library is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 details.
 You should have received a copy of the GNU Lesser General Public License
 along with this library; if not, write to the Free Software Foundation, Inc.,
 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

 Contact information:

 lat/lon GmbH
 Aennchenstr. 19, 53177 Bonn
 Germany
 http://lat-lon.de/

 Department of Geography, University of Bonn
 Prof. Dr. Klaus Greve
 Postfach 1147, 53001 Bonn
 Germany
 http://www.geographie.uni-bonn.de/deegree/

 e-mail: info@deegree.org
----------------------------------------------------------------------------*/
package org.deegree.ogcwebservices.sos.configuration;

import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;

import org.deegree.framework.xml.InvalidConfigurationException;
import org.deegree.ogcwebservices.getcapabilities.Contents;
import org.deegree.ogcwebservices.getcapabilities.OperationsMetadata;
import org.deegree.ogcwebservices.getcapabilities.ServiceIdentification;
import org.deegree.ogcwebservices.getcapabilities.ServiceProvider;
import org.deegree.ogcwebservices.sos.capabilities.SOSCapabilities;
import org.xml.sax.SAXException;

/**
 * represent the sos configuration
 *
 * @author <a href="mailto:mkulbe@lat-lon.de">Matthias Kulbe </a>
 *
 * @version 1.0
 */
public class SOSConfiguration extends SOSCapabilities {

    private SOSDeegreeParams sosDeegreeParams;

    /**
     * @param url
     *
     */
    public static SOSConfiguration create( URL url )
                            throws IOException, SAXException, InvalidConfigurationException {
        SOSConfigurationDocument confDoc = new SOSConfigurationDocument();
        confDoc.load( url );
        return confDoc.getConfiguration();
    }

    /**
     * @param sosDeegreeParams
     * @param sensorList
     * @param platformList
     * @param operationsMetadata
     * @param serviceProvider
     * @param serviceIdentification
     * @param updateSequence
     * @param version
     *
     */
    public SOSConfiguration( SOSDeegreeParams sosDeegreeParams, ArrayList sensorList, ArrayList platformList,
                             OperationsMetadata operationsMetadata, ServiceProvider serviceProvider,
                             ServiceIdentification serviceIdentification, String updateSequence, String version,
                             Contents contents ) {

        super( version, updateSequence, serviceIdentification, serviceProvider, operationsMetadata, contents,
               platformList, sensorList );

        this.sosDeegreeParams = sosDeegreeParams;
    }

    /**
     *
     * @return sosDeegreeParams
     */
    public SOSDeegreeParams getSOSDeegreeParams() {
        return sosDeegreeParams;
    }

}
