//$HeadURL: https://svn.wald.intevation.org/svn/deegree/base/branches/2.3_testing/src/org/deegree/ogcwebservices/sos/describeplatform/PlatformMetadata.java $
/*----------------------------------------------------------------------------
 This file is part of deegree, http://deegree.org/
 Copyright (C) 2001-2009 by:
   Department of Geography, University of Bonn
 and
   lat/lon GmbH

 This library is free software; you can redistribute it and/or modify it under
 the terms of the GNU Lesser General Public License as published by the Free
 Software Foundation; either version 2.1 of the License, or (at your option)
 any later version.
 This library is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 details.
 You should have received a copy of the GNU Lesser General Public License
 along with this library; if not, write to the Free Software Foundation, Inc.,
 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

 Contact information:

 lat/lon GmbH
 Aennchenstr. 19, 53177 Bonn
 Germany
 http://lat-lon.de/

 Department of Geography, University of Bonn
 Prof. Dr. Klaus Greve
 Postfach 1147, 53001 Bonn
 Germany
 http://www.geographie.uni-bonn.de/deegree/

 e-mail: info@deegree.org
----------------------------------------------------------------------------*/
package org.deegree.ogcwebservices.sos.describeplatform;

import org.deegree.ogcwebservices.sos.ComponentMetadata;
import org.deegree.ogcwebservices.sos.sensorml.Classifier;
import org.deegree.ogcwebservices.sos.sensorml.ComponentDescription;
import org.deegree.ogcwebservices.sos.sensorml.EngineeringCRS;
import org.deegree.ogcwebservices.sos.sensorml.Identifier;
import org.deegree.ogcwebservices.sos.sensorml.LocationModel;

/**
 * represents the metadata of one platform; extends the representation of a generic component; uses
 * SensorML
 *
 * @author <a href="mailto:mkulbe@lat-lon.de">Matthias Kulbe </a>
 * @author last edited by: $Author: mschneider $
 *
 * @version $Revision: 18195 $, $Date: 2009-06-18 17:55:39 +0200 (Do, 18. Jun 2009) $
 */
public class PlatformMetadata extends ComponentMetadata {

    // holds the id's of the docked components
    private String[] carries = null;

    /**
     * constructor
     *
     * @param identifiedAs
     * @param classifiedAs
     * @param hasCRS
     * @param locatedUsing
     * @param describedBy
     * @param attachedTo
     * @param carries
     */
    public PlatformMetadata( Identifier[] identifiedAs, Classifier[] classifiedAs,
                             EngineeringCRS hasCRS, LocationModel[] locatedUsing,
                             ComponentDescription describedBy, String attachedTo, String[] carries ) {

        super( identifiedAs, classifiedAs, hasCRS, locatedUsing, describedBy, attachedTo );

        this.carries = carries;

    }

    /**
     *
     * @return carries
     */
    public String[] getCarries() {
        return carries;
    }
}
