//$HeadURL: https://svn.wald.intevation.org/svn/deegree/base/branches/2.3_testing/src/org/deegree/ogcwebservices/sos/sensorml/Identifier.java $
/*----------------------------------------------------------------------------
 This file is part of deegree, http://deegree.org/
 Copyright (C) 2001-2009 by:
   Department of Geography, University of Bonn
 and
   lat/lon GmbH

 This library is free software; you can redistribute it and/or modify it under
 the terms of the GNU Lesser General Public License as published by the Free
 Software Foundation; either version 2.1 of the License, or (at your option)
 any later version.
 This library is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 details.
 You should have received a copy of the GNU Lesser General Public License
 along with this library; if not, write to the Free Software Foundation, Inc.,
 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

 Contact information:

 lat/lon GmbH
 Aennchenstr. 19, 53177 Bonn
 Germany
 http://lat-lon.de/

 Department of Geography, University of Bonn
 Prof. Dr. Klaus Greve
 Postfach 1147, 53001 Bonn
 Germany
 http://www.geographie.uni-bonn.de/deegree/

 e-mail: info@deegree.org
----------------------------------------------------------------------------*/
package org.deegree.ogcwebservices.sos.sensorml;

/**
 * represents a Identifier; please read the SensorML spec
 *
 * @author <a href="mailto:mkulbe@lat-lon.de">Matthias Kulbe </a>
 *
 */

public class Identifier {

    /**
     *
     */
    public static final int shortName = 1;

    /**
     *
     */
    public static final int longName = 2;

    /**
     *
     */
    public static final int serialNumber = 3;

    /**
     *
     */
    public static final int modelNumber = 4;

    /**
     *
     */
    public static final int missionNumber = 5;

    /**
     *
     */
    public static final int partNumber = 6;

    private String identifierValue = null;

    private int identifierType = 0;

    private String identifierCodeSpace = null;

    /**
     *
     * @param identifierValue
     * @param identifierType
     * @param identifierCodeSpace
     */
    public Identifier( String identifierValue, int identifierType, String identifierCodeSpace ) {

        this.identifierValue = identifierValue;

        if ( ( identifierType == 6 ) || ( identifierType == 1 ) || ( identifierType == 2 ) || ( identifierType == 3 )
             || ( identifierType == 4 ) || ( identifierType == 5 ) ) {
            this.identifierType = identifierType;
        }

        this.identifierCodeSpace = identifierCodeSpace;
    }

    /**
     *
     * @param identifierValue
     */
    public Identifier( String identifierValue ) {
        this.identifierValue = identifierValue;
    }

    /**
     *
     * @return code space
     */
    public String getIdentifierCodeSpace() {
        return identifierCodeSpace;
    }

    /**
     *
     * @return type
     */
    public int getIdentifierType() {
        return identifierType;
    }

    /**
     *
     * @return value
     */
    public String getIdentifierValue() {
        return identifierValue;
    }
}
