//$HeadURL: https://svn.wald.intevation.org/svn/deegree/base/branches/2.3_testing/src/org/deegree/ogcwebservices/sos/sensorml/Quantity.java $
/*----------------------------------------------------------------------------
 This file is part of deegree, http://deegree.org/
 Copyright (C) 2001-2009 by:
   Department of Geography, University of Bonn
 and
   lat/lon GmbH

 This library is free software; you can redistribute it and/or modify it under
 the terms of the GNU Lesser General Public License as published by the Free
 Software Foundation; either version 2.1 of the License, or (at your option)
 any later version.
 This library is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 details.
 You should have received a copy of the GNU Lesser General Public License
 along with this library; if not, write to the Free Software Foundation, Inc.,
 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

 Contact information:

 lat/lon GmbH
 Aennchenstr. 19, 53177 Bonn
 Germany
 http://lat-lon.de/

 Department of Geography, University of Bonn
 Prof. Dr. Klaus Greve
 Postfach 1147, 53001 Bonn
 Germany
 http://www.geographie.uni-bonn.de/deegree/

 e-mail: info@deegree.org
----------------------------------------------------------------------------*/
package org.deegree.ogcwebservices.sos.sensorml;

import java.net.URI;

/**
 * represents a Quantity; please read the SensorML spec
 *
 * @author <a href="mailto:mkulbe@lat-lon.de">Matthias Kulbe </a>
 *
 */

public class Quantity {

	private double value = Double.NaN;

	private boolean fixed = true;

	private URI uom = null;

	private double min = Double.NaN;

	private double max = Double.NaN;

    /**
     *
     * @param value
     */
	public Quantity(double value) {
		this.value = value;
	}

    /**
     *
     * @return fixed
     */
	public boolean isFixed() {
		return fixed;
	}

    /**
     *
     * @return max
     */
	public double getMax() {
		return max;
	}

    /**
     *
     * @return min
     */
	public double getMin() {
		return min;
	}

    /**
     *
     * @return uom
     */
	public URI getUom() {
		return uom;
	}

    /**
     *
     * @return value
     */
	public double getValue() {
		return value;
	}

    /**
     *
     * @param fixed
     */
	public void setFixed(boolean fixed) {
		this.fixed = fixed;
	}

    /**
     *
     * @param max
     */
	public void setMax(double max) {
		this.max = max;
	}

    /**
     *
     * @param min
     */
	public void setMin(double min) {
		this.min = min;
	}

    /**
     *
     * @param uom
     */
	public void setUom(URI uom) {
		this.uom = uom;
	}
}
