//$HeadURL: $
/*----------------------------------------------------------------------------
 This file is part of deegree, http://deegree.org/
 Copyright (C) 2001-2009 by:
   Department of Geography, University of Bonn
 and
   lat/lon GmbH

 This library is free software; you can redistribute it and/or modify it under
 the terms of the GNU Lesser General Public License as published by the Free
 Software Foundation; either version 2.1 of the License, or (at your option)
 any later version.
 This library is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 details.
 You should have received a copy of the GNU Lesser General Public License
 along with this library; if not, write to the Free Software Foundation, Inc.,
 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

 Contact information:

 lat/lon GmbH
 Aennchenstr. 19, 53177 Bonn
 Germany
 http://lat-lon.de/

 Department of Geography, University of Bonn
 Prof. Dr. Klaus Greve
 Postfach 1147, 53001 Bonn
 Germany
 http://www.geographie.uni-bonn.de/deegree/

 e-mail: info@deegree.org
----------------------------------------------------------------------------*/


package org.deegree.ogcwebservices.wcts.capabilities;

/**
 * <code>InputOutputFormat</code> TODO add documentation here
 *
 * @author <a href="mailto:bezema@lat-lon.de">Rutger Bezema</a>
 *
 * @author last edited by: $Author:$
 *
 * @version $Revision:$, $Date:$
 *
 */
public class InputOutputFormat {

    private final String value;
    private final boolean input;
    private final boolean output;

    /**
     * @param value
     * @param input
     * @param output
     */
    public InputOutputFormat( String value, boolean input, boolean output ) {
        this.value = value;
        this.input = input;
        this.output = output;

    }

    /**
     * @return the value.
     */
    public final String getValue() {
        return value;
    }

    /**
     * @return the input.
     */
    public final boolean canInput() {
        return input;
    }

    /**
     * @return the output.
     */
    public final boolean canOutput() {
        return output;
    }

}

