//$HeadURL: https://svn.wald.intevation.org/svn/deegree/base/branches/2.3_testing/src/org/deegree/portal/standard/sos/SOSClientException.java $

/*----------------------------------------------------------------------------
 This file is part of deegree, http://deegree.org/
 Copyright (C) 2001-2009 by:
   Department of Geography, University of Bonn
 and
   lat/lon GmbH

 This library is free software; you can redistribute it and/or modify it under
 the terms of the GNU Lesser General Public License as published by the Free
 Software Foundation; either version 2.1 of the License, or (at your option)
 any later version.
 This library is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 details.
 You should have received a copy of the GNU Lesser General Public License
 along with this library; if not, write to the Free Software Foundation, Inc.,
 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

 Contact information:

 lat/lon GmbH
 Aennchenstr. 19, 53177 Bonn
 Germany
 http://lat-lon.de/

 Department of Geography, University of Bonn
 Prof. Dr. Klaus Greve
 Postfach 1147, 53001 Bonn
 Germany
 http://www.geographie.uni-bonn.de/deegree/

 e-mail: info@deegree.org
----------------------------------------------------------------------------*/
package org.deegree.portal.standard.sos;

import org.deegree.framework.util.StringTools;
import org.deegree.portal.PortalException;

/**
 *
 * @author <a href="mailto:che@wupperverband.de>Christian Heier</a>
 * @author last edited by: $Author: mays$
 *
 * @version $Revision: 18195 $, $Date: 28.05.2008 17:08:46$
 */
public class SOSClientException extends PortalException {

    private static final long serialVersionUID = 6624884594209068372L;

    /**
     * Creates a new instance of <code>SOSClientExceptionn</code> without detail message.
     */
    public SOSClientException() {
        st = "SOSClientException";
    }

    /**
     * Constructs an instance of <code>SOSClientException</code> with the specified detail message.
     * @param msg the detail message.
     */
    public SOSClientException( String msg ) {
        super( msg );
        st = "SOSClientException";
    }

    /**
     * Constructs an instance of <code>SOSClientException</code> with the specified detail message.
     * @param msg the detail message.
     * @param e
     */
    public SOSClientException( String msg, Exception e ) {
        this( msg );
        st = StringTools.stackTraceToString( e.getStackTrace() );
    }

}
